/*****************************************************************************
 * ROMAPI_Boot_Time_Measurment.c
 *****************************************************************************/

#include <sys/platform.h>
#include "adi_initialize.h"
#include "ROMAPI_Boot_Time_Measurment.h"
#include <sys/platform.h>
#include <sys/adi_core.h>


#if defined(__ADSPSC839_FAMILY__)
#include <cdefSC83x_rom.h>
#include <defSC83x_rom.h>
#endif


#ifdef Single
#ifdef Dual
#ifdef Quad


void callback(void);
void load(void);
int32_t ROM_BOOT_HOOK_FUNC2(ADI_ROM_BOOT_CONFIG * pBootConfig, ROM_HOOK_CALL_CAUSE cause);





#ifdef ECDSA224
uint8_t PublicKey[] = {
		/* the Qx value */
		0x54, 0x79, 0xab, 0x3b,
		0xc4, 0x56, 0x08, 0x06,
		0x32, 0xe6, 0xf7, 0x83,
		0xed, 0xb9, 0xf6, 0xb9,
		0x68, 0x61, 0xea, 0xe7,
		0x36, 0x47, 0x8b, 0x91,
		0xd7, 0xfd, 0x46, 0xa4,
		0x00,0x00,0x00,0x00,

		/* the Qy value */
		0x97, 0xa5, 0x6d, 0x4b,
		0xe5, 0x45, 0x85, 0xa5,
		0x9a, 0x56, 0x8d, 0x83,
		0x09, 0xe3, 0x5f, 0x80,
		0xe1, 0x5e, 0x8c, 0x89,
		0x16, 0xb9, 0x57, 0x09,
		0xd5, 0x8e, 0xf6, 0xf1, /*CORRECT KEY*/
		//0xd5, 0x8e, 0xf6, 0xff,	/*INCORRECT KEY*/
		0x00,0x00,0x00,0x00
};
#endif
#ifdef ECDSA256
uint8_t PublicKey[] = {
		/* the Qx value */
		0x31, 0x14, 0x7d, 0xd3,
		0x76, 0x37, 0xc3, 0xd3,
		0x91, 0x00, 0x26, 0x31,
		0xed, 0x29, 0x88, 0xd0,
		0x4b, 0xa6, 0xb5, 0x69,
		0xb3, 0xbf, 0x7b, 0x4c,
		0x6b, 0xd9, 0x0f, 0x10,
		0x3e, 0xd5, 0x44, 0xa5,

		/* the Qy value */
		0xc8, 0xe1, 0xab, 0x1e,
		0x83, 0x9e, 0x2d, 0xdb,
		0xcb, 0x72, 0x75, 0x02,
		0x9a, 0xba, 0x51, 0x3a,
		0x85, 0x4b, 0x3d, 0xe4,
		0x8c, 0x0f, 0x7f, 0x98,
		0xa8, 0x7c, 0x3a, 0x38,
		0x89, 0x8b, 0x6a, 0x82 //correct
		//0x49, 0x8b, 0x6a, 0x82 //wrong

};
#endif
#ifdef Blx
uint8_t AESKey[] = {
		0x3a,0x65,0x26,0x30,0x97,0x55,0x27,0x7e,0xd2,0x3d,0x61,0xaf,0x6e,0x17,0x8f,0xa3 /*correct key*/
		//0x3a,0x65,0x26,0x30,0x97,0x55,0x27,0x7e,0xd2,0x3d,0x61,0xaf,0x6e,0x17,0x8f,0x3a /*wrong key*/
};
#endif
#ifdef Blw
uint8_t AESKey[] = {
		0x3a,0x65,0x26,0x30,0x97,0x55,0x27,0x7e,0xd2,0x3d,0x61,0xaf,0x6e,0x17,0x8f,0xa3 /*correct key*/
		//0x3a,0x65,0x26,0x30,0x97,0x55,0x27,0x7e,0xd2,0x3d,0x61,0xaf,0x6e,0x17,0x8f,0x3a /*wrong key*/
};
uint8_t AESwrapKey[]={
		0xBE,0x63,0xF3,0xC8,0X88,0X97,0XF5,0X6F,0X50,0X2D,0X23,0X97,0XD9,0X90,0X3E,0X39 /*correct key*/
		//0xBA,0x63,0xF3,0xC8,0X88,0X97,0XF5,0X6F,0X50,0X2D,0X23,0X97,0XD9,0X90,0X3E,0X39 /*wrong key*/
};
#endif

uint32_t BootCmd=0;
uint32_t START_ADDRESS=0;

int main(int argc, char *argv[])
{
	/**
	 * Initialize managed drivers and/or services that have been added to 
	 * the project.
	 * @return zero on success 
	 */
	*pREG_RCU0_MSG = 0x0;

	adi_initComponents();

	*pREG_SPU0_SECUREP94 = 0x3;
	*pREG_SPU0_SECUREP86 = 0x3;
	*pREG_SPU0_SECUREP87 = 0x3;
	*pREG_SPU0_SECUREP137 = 0x3;
	*pREG_SPU0_SECUREP138 = 0x3;
	*pREG_SPU0_SECUREP93 = 0x3;
	*pREG_SPU0_SECUREP84 = 0x3;
	*pREG_SPU0_SECUREP85 = 0x3;
	*pREG_SPU0_SECUREP137 = 0x3;
	*pREG_SPU0_SECUREP138 = 0x3;

	START_ADDRESS = 0x70000000;

#ifdef SPI_MASTER
#ifdef Single
	BootCmd =(1<<BITP_ROM_BCMD_SPIM_SPEED)|(2<<BITP_ROM_BCMD_SPIM_ADDR)|(1<<BITP_ROM_BCMD_SPIM_DUMMY)|
			(2<<BITP_ROM_BCMD_SPIM_BCODE)|(1<<BITP_ROM_BCMD_DEVENUM)|
			(1<<BITP_ROM_BCMD_SPIM_NOAUTO)|(7<<BITP_ROM_BCMD_DEVICE);
#endif
#ifdef Dual
	BootCmd =(1<<BITP_ROM_BCMD_SPIM_SPEED)|(2<<BITP_ROM_BCMD_SPIM_ADDR)|(1<<BITP_ROM_BCMD_SPIM_DUMMY)|
			(5<<BITP_ROM_BCMD_SPIM_BCODE)|(1<<BITP_ROM_BCMD_DEVENUM)|
			(1<<BITP_ROM_BCMD_SPIM_NOAUTO)|(7<<BITP_ROM_BCMD_DEVICE);
#endif
#ifdef Quad
	BootCmd =(1<<BITP_ROM_BCMD_SPIM_SPEED)|(2<<BITP_ROM_BCMD_SPIM_ADDR)|(3<<BITP_ROM_BCMD_SPIM_DUMMY)|
			(9<<BITP_ROM_BCMD_SPIM_BCODE)|(1<<BITP_ROM_BCMD_DEVENUM)|
			(1<<BITP_ROM_BCMD_SPIM_NOAUTO)|(7<<BITP_ROM_BCMD_DEVICE);
#endif
#endif
#ifdef XSPI_MASTER
	BootCmd = 0xA;
	START_ADDRESS = 0x60000000;
#endif

#ifdef LP_SLAVE
	BootCmd = 0x4;
	START_ADDRESS = 0x00000000;
#endif

#ifdef UART_SLAVE
	BootCmd = 0x3;
	START_ADDRESS = 0x00000000;
#endif


	/* Begin adding your custom code here */
	*pREG_PORTB_FER_CLR = (1 << 1);
	*pREG_PORTB_DIR_SET = (1 << 1);
	*pREG_PORTB_DATA_CLR = (1 << 1);

#if defined(Blp)||defined(Blx)||defined(Blw)
	adi_rom_Boot(START_ADDRESS, BITM_ROM_BFLAG_HOOK, 0,  &ROM_BOOT_HOOK_FUNC2,BootCmd);
#else
	adi_rom_Boot(START_ADDRESS, 0, 0, 0,BootCmd);
#endif
	return 0;
}

int32_t ROM_BOOT_HOOK_FUNC2(ADI_ROM_BOOT_CONFIG * pBootConfig, ROM_HOOK_CALL_CAUSE cause)
{
	if (cause == ROM_HOOK_CALL_INIT_COMPLETE)
	{
#if defined(Blp)||defined(Blx)||defined(Blw)
		pBootConfig->keyType = ADI_ROM_CUSTOM_SECURITY; /*To use custom key*/
		uint8_t *pPublicKey  = &pBootConfig->publicKey;
		uint8_t *pAESKey     = &pBootConfig->aesKey;

		int i=0;
		for(i=0;i<KEY_SIZE;i++)
		{
			pPublicKey[i] = PublicKey[i];
		}

#ifdef Blx
		for(i=0;i<16;i++)
		{
			pAESKey[i] = AESKey[i];
		}
#endif
#ifdef Blw
		for(i=0;i<16;i++)
		{
			pAESKey[i] = AESKey[i];
		}
#endif
#endif
		asm("NOP;");
	}
	if (cause == ROM_HOOK_CALL_CONFIG_COMPLETE)
	{
		asm("NOP;");
	}
	if (cause == ROM_HOOK_REG_COMPLETE)
	{
		asm("NOP;");
	}

	return 0;
}
